diff -pruN 0.4.0~alpha7-2/debian/TODO 0.4.0~alpha7-3/debian/TODO
--- 0.4.0~alpha7-2/debian/TODO	2024-07-02 11:59:41.000000000 +0000
+++ 0.4.0~alpha7-3/debian/TODO	2024-07-09 18:03:18.000000000 +0000
@@ -4,3 +4,5 @@
   * provide crate oxigraph_js when wasm-pack is in Debian
   * package Python bindings
     when understood how to use Python module maturin
+  * check tests "test_backup" and "test_secondary"
+    when they support linking against RocksDB 9.x
diff -pruN 0.4.0~alpha7-2/debian/changelog 0.4.0~alpha7-3/debian/changelog
--- 0.4.0~alpha7-2/debian/changelog	2024-07-05 06:27:15.000000000 +0000
+++ 0.4.0~alpha7-3/debian/changelog	2024-07-09 18:04:26.000000000 +0000
@@ -1,3 +1,11 @@
+oxigraph (0.4.0~alpha7-3) unstable; urgency=medium
+
+  * add patch cherry-picked upstream
+    to avoid AtomicU64 unsupported on armel
+  * skip tests that expects linking against RocksDB 8.x
+
+ -- Jonas Smedegaard <dr@jones.dk>  Tue, 09 Jul 2024 20:04:26 +0200
+
 oxigraph (0.4.0~alpha7-2) experimental; urgency=medium
 
   * update dh-cargo fork
diff -pruN 0.4.0~alpha7-2/debian/copyright_hints 0.4.0~alpha7-3/debian/copyright_hints
--- 0.4.0~alpha7-2/debian/copyright_hints	2024-07-05 06:24:32.000000000 +0000
+++ 0.4.0~alpha7-3/debian/copyright_hints	2024-07-09 18:04:11.000000000 +0000
@@ -36,6 +36,7 @@ Files: CHANGELOG.md
  debian/not-installed
  debian/oxigraph.docs
  debian/oxigraph.manpages
+ debian/patches/020240708~ba32a0d.patch
  debian/patches/2001_wasm32.patch
  debian/patches/2002_use_shared_rocksdb.patch
  debian/patches/2003_avoid_testsuite.patch
diff -pruN 0.4.0~alpha7-2/debian/patches/020240708~ba32a0d.patch 0.4.0~alpha7-3/debian/patches/020240708~ba32a0d.patch
--- 0.4.0~alpha7-2/debian/patches/020240708~ba32a0d.patch	1970-01-01 00:00:00.000000000 +0000
+++ 0.4.0~alpha7-3/debian/patches/020240708~ba32a0d.patch	2024-07-09 17:54:26.000000000 +0000
@@ -0,0 +1,116 @@
+Description: Memory store: use usize for version counter
+ Makes portability easier.
+ Not sure we need more than 2B in-memory transactions
+ on 32bits platforms.
+Author: Thomas Tanon <thomas@pellissier-tanon.fr>
+Origin: upstream, https://github.com/oxigraph/oxigraph/commit/ba32a0d
+Bug: https://github.com/oxigraph/oxigraph/issues/913
+Last-Update: 2024-07-09
+---
+This patch header follows DEP-3: http://dep.debian.net/deps/dep3/
+--- a/lib/oxigraph/src/storage/memory.rs
++++ b/lib/oxigraph/src/storage/memory.rs
+@@ -13,7 +13,7 @@
+ use std::error::Error;
+ use std::hash::{BuildHasherDefault, Hash, Hasher};
+ use std::mem::transmute;
+-use std::sync::atomic::{AtomicU64, Ordering};
++use std::sync::atomic::{AtomicUsize, Ordering};
+ use std::sync::{Arc, Mutex, RwLock};
+ 
+ /// In-memory storage working with MVCC
+@@ -24,8 +24,8 @@
+ pub struct MemoryStorage {
+     content: Arc<Content>,
+     id2str: Arc<DashMap<StrHash, String, BuildHasherDefault<StrHashHasher>>>,
+-    version_counter: Arc<AtomicU64>,
+-    transaction_counter: Arc<Mutex<u64>>,
++    version_counter: Arc<AtomicUsize>,
++    transaction_counter: Arc<Mutex<usize>>,
+ }
+ 
+ struct Content {
+@@ -55,8 +55,9 @@
+                 graphs: DashMap::default(),
+             }),
+             id2str: Arc::new(DashMap::default()),
+-            version_counter: Arc::new(AtomicU64::new(0)),
+-            transaction_counter: Arc::new(Mutex::new(u64::MAX >> 1)),
++            version_counter: Arc::new(AtomicUsize::new(0)),
++            #[allow(clippy::mutex_atomic)]
++            transaction_counter: Arc::new(Mutex::new(usize::MAX >> 1)),
+         }
+     }
+ 
+@@ -135,7 +136,7 @@
+ #[derive(Clone)]
+ pub struct MemoryStorageReader {
+     storage: MemoryStorage,
+-    snapshot_id: u64,
++    snapshot_id: usize,
+ }
+ 
+ impl MemoryStorageReader {
+@@ -453,7 +454,7 @@
+ pub struct MemoryStorageWriter<'a> {
+     storage: &'a MemoryStorage,
+     log: &'a mut Vec<LogEntry>,
+-    transaction_id: u64,
++    transaction_id: usize,
+ }
+ 
+ impl<'a> MemoryStorageWriter<'a> {
+@@ -877,13 +878,13 @@
+ enum VersionRange {
+     #[default]
+     Empty,
+-    Start(u64),
+-    StartEnd(u64, u64),
+-    Bigger(Box<[u64]>),
++    Start(usize),
++    StartEnd(usize, usize),
++    Bigger(Box<[usize]>),
+ }
+ 
+ impl VersionRange {
+-    fn contains(&self, version: u64) -> bool {
++    fn contains(&self, version: usize) -> bool {
+         match self {
+             VersionRange::Empty => false,
+             VersionRange::Start(start) => *start <= version,
+@@ -909,7 +910,7 @@
+         }
+     }
+ 
+-    fn add(&mut self, version: u64) -> bool {
++    fn add(&mut self, version: usize) -> bool {
+         match self {
+             VersionRange::Empty => {
+                 *self = VersionRange::Start(version);
+@@ -939,7 +940,7 @@
+         }
+     }
+ 
+-    fn remove(&mut self, version: u64) -> bool {
++    fn remove(&mut self, version: usize) -> bool {
+         match self {
+             VersionRange::Empty | VersionRange::StartEnd(_, _) => false,
+             VersionRange::Start(start) => {
+@@ -968,7 +969,7 @@
+         }
+     }
+ 
+-    fn upgrade_transaction(&mut self, transaction_id: u64, version_id: u64) {
++    fn upgrade_transaction(&mut self, transaction_id: usize, version_id: usize) {
+         match self {
+             VersionRange::Empty => (),
+             VersionRange::Start(start) => {
+@@ -989,7 +990,7 @@
+         }
+     }
+ 
+-    fn rollback_transaction(&mut self, transaction_id: u64) {
++    fn rollback_transaction(&mut self, transaction_id: usize) {
+         match self {
+             VersionRange::Empty => (),
+             VersionRange::Start(start) => {
diff -pruN 0.4.0~alpha7-2/debian/patches/series 0.4.0~alpha7-3/debian/patches/series
--- 0.4.0~alpha7-2/debian/patches/series	2024-07-02 11:52:19.000000000 +0000
+++ 0.4.0~alpha7-3/debian/patches/series	2024-07-09 17:51:22.000000000 +0000
@@ -1,3 +1,4 @@
+020240708~ba32a0d.patch
 2001_wasm32.patch
 2002_use_shared_rocksdb.patch
 2003_avoid_testsuite.patch
diff -pruN 0.4.0~alpha7-2/debian/rules 0.4.0~alpha7-3/debian/rules
--- 0.4.0~alpha7-2/debian/rules	2024-07-02 11:58:02.000000000 +0000
+++ 0.4.0~alpha7-3/debian/rules	2024-07-09 18:04:26.000000000 +0000
@@ -30,9 +30,14 @@ ifneq (,$(filter $(DEB_HOST_ARCH),armel
 TOLERATE_TEST_FAILURE = 1
 endif
 
-# tests require write access to hardcoded path <tests/rocksdb_bc_data>
+# * test_backward_compatibility require write access to hardcoded path
+#   <tests/rocksdb_bc_data>
+# * tests test_backup test_secondary expect linking against RocksDB 8.x
+#   <https://github.com/oxigraph/oxigraph/issues/914>
 TEST_BROKEN = \
- test_backward_compatibility
+ test_backup \
+ test_backward_compatibility \
+ test_secondary
 
 %:
 	dh $@ --buildsystem cargo
diff -pruN 0.4.0~alpha7-2/debian/tests/control 0.4.0~alpha7-3/debian/tests/control
--- 0.4.0~alpha7-2/debian/tests/control	2024-07-02 11:27:43.000000000 +0000
+++ 0.4.0~alpha7-3/debian/tests/control	2024-07-09 18:00:41.000000000 +0000
@@ -324,7 +324,9 @@ Restrictions: allow-stderr
 Test-Command: /usr/share/cargo/bin/cargo-auto-test oxigraph 0.4.0-alpha.7
  --all-targets --all-features
  --no-fail-fast --
+ --skip test_backup
  --skip test_backward_compatibility
+ --skip test_secondary
 Features: test-name=rust-oxigraph:@
 Depends:
  dh-cargo,
@@ -337,7 +339,9 @@ Architecture: !armel !armhf !arm64
 Test-Command: /usr/share/cargo/bin/cargo-auto-test oxigraph 0.4.0-alpha.7
  --all-targets --no-default-features
  --no-fail-fast --
+ --skip test_backup
  --skip test_backward_compatibility
+ --skip test_secondary
 Features: test-name=rust-oxigraph:
 Depends:
  dh-cargo,
@@ -350,7 +354,9 @@ Architecture: !armel !armhf !arm64
 Test-Command: /usr/share/cargo/bin/cargo-auto-test oxigraph 0.4.0-alpha.7
  --all-targets
  --no-fail-fast --
+ --skip test_backup
  --skip test_backward_compatibility
+ --skip test_secondary
 Features: test-name=rust-oxigraph:default
 Depends:
  dh-cargo,
@@ -363,7 +369,9 @@ Architecture: !armel !armhf !arm64
 Test-Command: /usr/share/cargo/bin/cargo-auto-test oxigraph 0.4.0-alpha.7
  --all-targets --no-default-features --features http_client
  --no-fail-fast --
+ --skip test_backup
  --skip test_backward_compatibility
+ --skip test_secondary
 Features: test-name=rust-oxigraph:http_client
 Depends:
  dh-cargo,
@@ -376,7 +384,9 @@ Architecture: !armel !armhf !arm64
 Test-Command: /usr/share/cargo/bin/cargo-auto-test oxigraph 0.4.0-alpha.7
  --all-targets --no-default-features --features rocksdb_debug
  --no-fail-fast --
+ --skip test_backup
  --skip test_backward_compatibility
+ --skip test_secondary
 Features: test-name=rust-oxigraph:rocksdb_debug
 Depends:
  dh-cargo,
@@ -389,7 +399,9 @@ Architecture: !armel !armhf !arm64
 Test-Command: /usr/share/cargo/bin/cargo-auto-test oxigraph 0.4.0-alpha.7
  --all-targets --all-features
  --no-fail-fast --
+ --skip test_backup
  --skip test_backward_compatibility
+ --skip test_secondary
 Features: test-name=rust-oxigraph:@
 Depends:
  dh-cargo,
@@ -402,7 +414,9 @@ Architecture: armel armhf arm64
 Test-Command: /usr/share/cargo/bin/cargo-auto-test oxigraph 0.4.0-alpha.7
  --all-targets --no-default-features
  --no-fail-fast --
+ --skip test_backup
  --skip test_backward_compatibility
+ --skip test_secondary
 Features: test-name=rust-oxigraph:
 Depends:
  dh-cargo,
@@ -415,7 +429,9 @@ Architecture: armel armhf arm64
 Test-Command: /usr/share/cargo/bin/cargo-auto-test oxigraph 0.4.0-alpha.7
  --all-targets
  --no-fail-fast --
+ --skip test_backup
  --skip test_backward_compatibility
+ --skip test_secondary
 Features: test-name=rust-oxigraph:default
 Depends:
  dh-cargo,
@@ -428,7 +444,9 @@ Architecture: armel armhf arm64
 Test-Command: /usr/share/cargo/bin/cargo-auto-test oxigraph 0.4.0-alpha.7
  --all-targets --no-default-features --features http_client
  --no-fail-fast --
+ --skip test_backup
  --skip test_backward_compatibility
+ --skip test_secondary
 Features: test-name=rust-oxigraph:http_client
 Depends:
  dh-cargo,
@@ -441,7 +459,9 @@ Architecture: armel armhf arm64
 Test-Command: /usr/share/cargo/bin/cargo-auto-test oxigraph 0.4.0-alpha.7
  --all-targets --no-default-features --features rocksdb_debug
  --no-fail-fast --
+ --skip test_backup
  --skip test_backward_compatibility
+ --skip test_secondary
 Features: test-name=rust-oxigraph:rocksdb_debug
 Depends:
  dh-cargo,
